From 3d27c83831686244ae98130d20beb0b7d186717c Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:30 +0000
Subject: [PATCH 10/17] reimplement runner integration tests


---

diff --git a/kiskadee/api/app.py b/kiskadee/api/app.py
index e39e133..f484bc4 100644
--- a/kiskadee/api/app.py
+++ b/kiskadee/api/app.py
@@ -46,14 +46,10 @@ def package_analysis_overview(pkg_name, version):
     db_session = kiskadee_db_session()
 
     #TODO: This can be a simple inner join between package, version and analysis
-    package_id = (
-            db_session.query(Package).filter_by(name = pkg_name).id
-        )
-    version_id = (
-            db_session.query(Version)
-            .filter(Version.number == version)
+    package_id = db_session.query(Package).filter_by(name = pkg_name).id
+    version_id = db_session.query(Version)\
+            .filter(Version.number == version)\
             .filter(Version.package_id == package_id).first().id
-        )
     analysis = (
             db_session.query(Analysis)
             .options(
@@ -62,8 +58,6 @@ def package_analysis_overview(pkg_name, version):
             .filter(Analysis.version_id == version_id)
             .all()
         )
-    kiskadee.logger.debug("haaaaaaa")
-    kiskadee.logger.debug(analysis)
     analysis_schema = AnalysisSchema(many=True, exclude=['raw', 'report'])
     data, errors = analysis_schema.dump(analysis)
     return jsonify(data)
@@ -76,10 +70,7 @@ def package_analysis_overview(pkg_name, version):
 def analysis_results(pkg_name, version, analysis_id):
     """Get the analysis results from a specific analyzer."""
     db_session = kiskadee_db_session()
-    analysis = (
-            db_session.query(Analysis)
-            .get(analysis_id)
-        )
+    analysis = db_session.query(Analysis).get(analysis_id)
     analysis_schema = AnalysisSchema(only=['raw'])
     data, errors = analysis_schema.dump(analysis)
     response = data['raw']['results']
@@ -93,26 +84,20 @@ def analysis_results(pkg_name, version, analysis_id):
 def analysis_reports(pkg_name, version, analysis_id):
     """Get the analysis reports from a specific analyzer."""
     db_session = kiskadee_db_session()
-    analysis = (
-            db_session.query(Analysis)
-            .get(analysis_id)
-        )
-    analysis_schema = AnalysisSchema(only=['report'])
-    data, errors = analysis_schema.dump(analysis)
+    analysis = db_session.query(Analysis).get(analysis_id)
+    data, errors = AnalysisSchema(only=['report']).dump(analysis)
     report = data['report']
-    if (report is not None) and\
-        ('results' in report.keys()) and\
-            report['results'] is not None:
-        report['results'] = json\
-            .loads(report['results'])
-    return jsonify({'analysis_report': report})
+    try:
+        report['results'] = json.loads(report['results'])
+        return jsonify({'analysis_report': report})
+    except Exception as err:
+        return jsonify({'analysis_report': {}})
 
 
 def kiskadee_db_session():
     """Return a kiskadee database session."""
     return Database().session
 
-
 def main():
     """Initialize the kiskadee API."""
     kiskadee.run('0.0.0.0')
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index 9490b2a..0fc6755 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -23,6 +23,7 @@ class Monitor:
         """Return a non initialized Monitor."""
         self.session = _session
         self.queues = queues
+        kiskadee.model.Analyzer.create_analyzers(self.session)
 
     def start(self):
         kiskadee.logger.debug('Monitor PID: {}'.format(os.getpid()))
@@ -96,7 +97,7 @@ def daemon():
     queues = kiskadee.queue.Queues()
     session = kiskadee.database.Database().session
     monitor = Monitor(session, queues)
-    runner = Runner(session, queues)
+    runner = Runner(queues)
     monitor_process = Process(
             target=monitor.start,
         )
diff --git a/kiskadee/runner.py b/kiskadee/runner.py
index 607fdef..dfe02a0 100644
--- a/kiskadee/runner.py
+++ b/kiskadee/runner.py
@@ -16,12 +16,11 @@ RUNNING = True
 class Runner:
     """Provide kiskadee runner objects."""
 
-    def __init__(self, session, queues):
+    def __init__(self, queues):
         """Return a non initialized Runner."""
         self.queues = queues
-        self.session = session
-        kiskadee.model.Analyzer.create_analyzers(self.session)
         self.fetcher = None
+        self.project = None
 
     def runner(self, queues):
         """Run static analyzers.
@@ -34,59 +33,50 @@ class Runner:
         while RUNNING:
             kiskadee.logger.debug('RUNNER: Waiting to dequeue'\
                                   ' project to analysis...')
-            project_to_analysis = self.queues.dequeue_analysis()
-            self.call_analyzers(project_to_analysis)
+            self.project = self.queues.dequeue_analysis()
+            self.call_analyzers()
 
-    def load_project_fetcher(self, project_to_analysis):
+    def import_project_fetcher(self):
         try:
-        return importlib.import_module(
-                project_to_analysis['fetcher']
-                ).Fetcher()
+            return importlib.import_module(
+                    self.project['fetcher']
+                    ).Fetcher()
         except ModuleNotFoundError:
             kiskadee.logger.debug("Fetcher {} could not be loaded"\
-                    .format(project_to_analysis['fetcher'])
+                    .format(self.project['fetcher'])
                 )
             return {}
 
-    def uncompress_project_code(self, compressed_source):
-        dir_to_unpack_source = tempfile.mkdtemp()
-        try:
-            shutil.unpack_archive(compressed_source,
-                    dir_to_unpack_source)
-            return dir_to_unpack_source
-        except Exception as err:
-            kiskadee.logger.debug('Could not unpack project source')
-            kiskadee.logger.debug(err)
-            return {}
-
-    def run_analysis(self, analyzers, project_to_analysis):
-        project_to_analysis['results'] = {}
+    def run_analysis(self, analyzers, source_path):
+        self.project['results'] = {}
         for analyzer in analyzers:
             firehose_report = self.analyze(analyzer, source_path)
             if firehose_report:
-                project_to_analysis['results'][analyzer] = firehose_report
-        return project_to_analysis
+                self.project['results'][analyzer] = firehose_report
+        return self.project
 
 
-    def clean_temporary_directory(self, dir):
+    def clean_temporary_directory(self, temp_dir):
         # not delete the source code used on tests.
-        if not compressed_source_path .find("kiskadee/tests") > -1:
-            shutil.rmtree(os.path.dirname(dir))
+        if not temp_dir.find("kiskadee/tests") > -1:
+            shutil.rmtree(temp_dir)
 
-    def call_analyzers(self, project_to_analysis):
+    def call_analyzers(self):
         """Iterate over the package analyzers.
 
         For each analyzer defined to analysis the source, call
         the function :func:`analyze`, passing the source dict, the analyzer
         to run the analysis, and the path to a compressed source.
         """
-        self.fetcher = self.load_project_fetcher(project_to_analysis)
-        source_path = self.prepare_to_get_project_code(project_to_analysis)
+        self.fetcher = self.import_project_fetcher()
+        source_path = self.get_project_code_path()
         if not source_path:
             return None
 
-        analyzers = fetcher.analyzers()
-        analysis_result = self.run_analysis(analyzers, project_to_analysis)
+        analyzers = self.fetcher.analyzers()
+        analysis_result = self.run_analysis(
+                analyzers, source_path
+                )
         self.enqueue_analysis_to_monitor(analysis_result)
         self.clean_temporary_directory(source_path)
 
@@ -121,14 +111,14 @@ class Runner:
             kiskadee.logger.debug(err)
             return None
 
-    def prepare_to_get_project_code(self, project):
+    def get_project_code_path(self):
 
-        if not (self.fetcher and project):
+        if not (self.fetcher and self.project):
             return None
 
-        compressed_source_path = self.fetcher.get_sources(project)
+        compressed_source_path = self.fetcher.get_sources(self.project)
         if compressed_source_path :
-            uncompressed_source_path = uncompress_project_code(
+            uncompressed_source_path = self.uncompress_project_code(
                     compressed_source_path
                     )
             self.clean_temporary_directory(os.path.dirname(compressed_source_path))
@@ -136,3 +126,15 @@ class Runner:
         else:
             kiskadee.logger.debug('RUNNER: invalid compressed source')
             return None
+
+    def uncompress_project_code(self, compressed_source):
+        dir_to_unpack_source = tempfile.mkdtemp()
+        try:
+            shutil.unpack_archive(compressed_source,
+                    dir_to_unpack_source)
+            return dir_to_unpack_source
+        except Exception as err:
+            kiskadee.logger.debug('Could not unpack project source')
+            kiskadee.logger.debug(err)
+            return {}
+
diff --git a/kiskadee/tests/api/test_api.py b/kiskadee/tests/api/test_api.py
index 7c8d021..1ef5b8a 100644
--- a/kiskadee/tests/api/test_api.py
+++ b/kiskadee/tests/api/test_api.py
@@ -17,6 +17,7 @@ class ApiTestCase(unittest.TestCase):
 
     def setUp(self):
         self.fetcher = kiskadee.model.Fetcher(name='kiskadee-fetcher')
+        self.queues = kiskadee.queue.Queues()
 
     def test_get_fetchers(self):
         kiskadee.api.app.kiskadee_db_session = MagicMock()
@@ -39,15 +40,8 @@ class ApiTestCase(unittest.TestCase):
                 raw='analysis result: foo'
                 )
 
-        def side_effect(klass):
-            mocked_objects = {
-                    'Package': package,
-                    'Version': version,
-                    }
-            return mocked_objects[klass.__name__]
-
         kiskadee.api.app.kiskadee_db_session = MagicMock()
-        Monitor(kiskadee.api.app.kiskadee_db_session())
+        Monitor(kiskadee.api.app.kiskadee_db_session(), self.queues)
         db_session = kiskadee.api.app.kiskadee_db_session()
         db_session.query(kiskadee.model.Package)\
                   .filter_by().id = MagicMock()
diff --git a/kiskadee/tests/integration/test_runner.py b/kiskadee/tests/integration/test_runner.py
index d2f08df..3cd646f 100644
--- a/kiskadee/tests/integration/test_runner.py
+++ b/kiskadee/tests/integration/test_runner.py
@@ -4,97 +4,54 @@ by the user that is executing the tests. It also needs selinux running in
 a permissive mode (setenforce 0)
 """
 import unittest
-import tempfile
+import re
+from unittest.mock import MagicMock
 
-from kiskadee.runner import Runner
+import kiskadee.queue
+import kiskadee.runner
+import kiskadee.monitor
 import kiskadee.fetchers.example
-import kiskadee.fetchers.debian
-from sqlalchemy.orm import sessionmaker
-from kiskadee import model
-from kiskadee.queue import Queues
-from kiskadee.database import Database
+import kiskadee.analyzers
 
+class RunnerTestCase(unittest.TestCase):
 
-class AnalyzersTestCase(unittest.TestCase):
-    def setUp(self):
-        self.engine = Database('db_test').engine
-        Session = sessionmaker(bind=self.engine)
-        self.session = Session()
-        model.Base.metadata.create_all(self.engine)
-        model.Analyzer.create_analyzers(self.session)
-        self.fetcher = kiskadee.fetchers.debian.Fetcher()
-        self.deb_pkg = {'name': 'test',
-                        'version': '1.0.0',
-                        'fetcher': kiskadee.fetchers.debian.__name__
-                        }
-        self.fetcher = model.Fetcher(
-                name='kiskadee-fetcher2', target='university'
-            )
-        self.session.add(self.fetcher)
-        self.session.commit()
-        self.runner = Runner()
-        self.runner.queues = Queues()
-
-    def tearDown(self):
-        self.session.close()
-        model.Base.metadata.drop_all()
-
-    def test_run_analyzer(self):
-
-        source_to_analysis = {
-                'name': 'test',
-                'version': '1.0.0',
-                'fetcher': kiskadee.fetchers.example.Fetcher()
-        }
+    """Docstring for AnalyzersTestCase. """
 
-        source_path = self.runner._path_to_uncompressed_source(
-                source_to_analysis, kiskadee.fetchers.example.Fetcher()
-            )
-        firehose_report = self.runner.analyze("cppcheck", source_path)
-        self.assertIsNotNone(firehose_report)
+    def setUp(self):
+        self.queues = kiskadee.queue.Queues()
+        self.runner = kiskadee.runner.Runner(self.queues)
 
-    def test_generate_a_firehose_report(self):
-        source_to_analysis = {
+        self.project = {
                 'name': 'test',
                 'version': '1.0.0',
                 'fetcher': kiskadee.fetchers.example.__name__
         }
 
-        self.runner.call_analyzers(source_to_analysis)
-        analyzed_pkg = self.runner.queues.dequeue_result()
-        self.assertEqual(analyzed_pkg['name'], source_to_analysis['name'])
-        self.assertIn('cppcheck', analyzed_pkg['results'])
-        self.assertIn('flawfinder', analyzed_pkg['results'])
-
-    def test_path_to_uncompressed_source(self):
-
-        source_to_analysis = {
-                'name': 'test',
-                'version': '1.0.0',
-                'fetcher': kiskadee.fetchers.example
-        }
-
-        source_path = self.runner._path_to_uncompressed_source(
-                source_to_analysis, kiskadee.fetchers.example.Fetcher()
-        )
-        tmp_path = tempfile.gettempdir()
-        self.assertTrue(source_path.find(tmp_path) >= 0)
-        self.assertIsNotNone(source_path)
-
-    def test_invalid_path_to_uncompressed_source(self):
-
-        source_to_analysis = {
-                'name': 'test',
-                'version': '1.0.0',
-                'fetcher': kiskadee.fetchers.example
-        }
-
-        source_path = self.runner._path_to_uncompressed_source(
-                source_to_analysis, None
-        )
-
-        self.assertIsNone(source_path)
-
+    def tearDown(self):
+        """TODO: to be defined1. """
+
+    def test_run_analyzers(self):
+        self.runner.project = self.project
+        self.runner.call_analyzers()
+        result = self.queues.dequeue_result()
+        self.assertEqual(result['name'], 'test')
+        self.assertIn('results', result)
+
+    def test_run_a_single_analyzer(self):
+        self.runner.project = self.project
+        self.runner.fetcher = self.runner.import_project_fetcher()
+        source_path = self.runner.get_project_code_path()
+        analyzer = self.runner.fetcher.analyzers()[0]
+        self.assertIsNotNone(re.search('.*cppcheck.*', analyzer))
+        self.assertIsNone(re.search('.*pylint.*', analyzer))
+
+    def test_analysis_an_incoming_monitor_project(self):
+        self.session = MagicMock()
+        self.session.query().filter_by().first = MagicMock(return_value={})
+        self.monitor = kiskadee.monitor.Monitor(self.session, self.queues)
+        self.monitor.send_project_to_runner(self.project)
+        incoming_project = self.runner.queues.dequeue_analysis()
+        self.assertEqual(self.project, incoming_project)
 
 if __name__ == '__main__':
     unittest.main()

